/*
 *  AreaLight.cpp
 *  FinalImage
 *
 *  Created by Zach Gildersleeve on 4/13/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "AreaLight.h"

AreaLight::AreaLight(const Point &newP1, const Point &newP2, const Point &newP3, const Color &newLightColor)
: position(newP1), lightColor(newLightColor) {
	v1 = newP2 - newP1;
	v2 = newP3 - newP1;
}

AreaLight::~AreaLight() {
	
}

void AreaLight::preprocess() {
	
}

/**
*	Returns normalized direction
 */
double AreaLight::getLight(Color &color, Vector &lightDirection,
							const RenderContext &context,
							const Point &location) const {
	color = lightColor;
	Vector direction = position - location;
	direction += v1 * ((rand() % 100)-50) * 0.1;
	direction += v2 * ((rand() % 100)-50) * 0.1;
	
	double distanceToLight = direction.normalize();
	lightDirection = direction;
	return distanceToLight;
							}