/*
 *  PhongBumpMaterial.h
 *  FinalImage
 *
 *  Created by Zach Gildersleeve on 4/18/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PHONGBUMPMATERIAL_H
#define PHONGBUMPMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"

class PhongBumpMaterial : public Material {
public:
	PhongBumpMaterial(const Color &newColor, double newKdiffuse,
				  double newKambient, const Color &newSpecColor,
				  int newPhongTerm, Material *newBumpMap, double newDepth);
	virtual ~PhongBumpMaterial() {}
	
	virtual void preprocess() {}
	void shade(Color &result, const RenderContext &context,
			   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
		
private:
		Color color;
	double Kambient;
	double Kdiffuse;
	Color specColor;
	int phongTerm;
	Material *bumpMap;
	double bumpDepth;
};

#endif