/*
 *  ThinLensCamera.h
 *  Assignment10
 *
 *  Created by Zach Gildersleeve on 4/22/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef THINLENSCAMERA_H
#define THINLENSCAMERA_H

#include "Camera.h"
#include "Point.h"
#include "Vector.h"
#include "Ray.h"
#include <math.h>

class ThinLensCamera : public Camera {
	public:
		ThinLensCamera(const Point &newPosition, const Point &newLookat, const Vector &newUp, double newfov, double newAperture, double newFocalDistance);
		~ThinLensCamera() {}
		
		virtual void preprocess(double aspectRatio);
		virtual void makeRay(Ray &ray, const RenderContext &context, double x, double y) const;

	private:
	Point position;
	Point lookat;
	Vector up;
	double fov;
	Vector u;
	Vector v;
	Vector normalDirection;
	double aperture;
	double focalDistance;
	double lensRadius;
	
};

#endif